#include <windows.h>
#include "diskgraf.h"

double freeDiskMB;
double totalDiskMB;

DWORD SectorsPerCluster; 
DWORD BytesPerSector; 
DWORD NumberOfFreeClusters;  
DWORD TotalNumberOfClusters;  

ULARGE_INTEGER  free1;
ULARGE_INTEGER  total;
ULARGE_INTEGER  free2;

char  version[50] = "DiskGraf Version 1.3A";

int GetDiskStats()
{
    HINSTANCE hLib = NULL;
    char  getName[30] = "GetDiskFreeSpaceExA";
    
    if (build > 1000)
    {
        hLib = LoadLibraryA("KERNEL32.DLL");
    }
    if (hLib)
    {
        typedef BOOL (WINAPI *MyFunc)(LPCTSTR RootName, PULARGE_INTEGER  free1, PULARGE_INTEGER  total, PULARGE_INTEGER  free2);
        MyFunc GetDiskData = (MyFunc)GetProcAddress(hLib, getName);
        GetDiskData(NULL, &free1, &total, &free2);
        freeDiskMB =  4096.0F * (double)free1.HighPart +
          (double)((unsigned int) free1.LowPart) / 1024.0F / 1024.0F;   
        totalDiskMB =  4096.0F * (double)total.HighPart +
          (double)((unsigned int) total.LowPart) / 1024.0F / 1024.0F;
        FreeLibrary(hLib);
    }
    else
    {
       GetDiskFreeSpace(NULL, &SectorsPerCluster, &BytesPerSector,  
                &NumberOfFreeClusters, &TotalNumberOfClusters);
       freeDiskMB =  (double) NumberOfFreeClusters *
                     (double) SectorsPerCluster *
                     (double) BytesPerSector / 1048576.0;
       totalDiskMB = (double) TotalNumberOfClusters *
                     (double) SectorsPerCluster *
                     (double) BytesPerSector / 1048576.0;
    }
    return 1;
}


